<?php
// szotyi szkriptje alapján készítette: prodigital.hu
// Magento 2.4-re aktualizálta: Clear Admin Software Kft.

use Magento\Framework\App\Bootstrap;

require_once '../../app/bootstrap.php';

$params = $_SERVER;

$bootstrap = Bootstrap::create(BP, $params);

$obj = $bootstrap->getObjectManager();

$state = $obj->get('Magento\Framework\App\State');
$state->setAreaCode('frontend');

function sz_cElement($root, $parent, $name, $value) {
    $parent->appendChild($root->createElement($name))->appendChild($root->createTextNode($value));
}


//induló sorszám
$lastexported = 0;

 //echo $dom;
 
 $dom = new DomDocument('2.0'); 
 $orders = $dom->appendChild($dom->createElement('ORDERS'));


 $killer=false;
 $currentorder=$lastexported+1;
 
 $objectManager = \Magento\Framework\App\ObjectManager::getInstance();  
 
 $orderDatamodel = $objectManager->get('Magento\Sales\Model\Order')->getCollection()->getLastItem();
 $lastorderId   =   $orderDatamodel->getId();
 
 while ($killer==false && $currentorder<=$lastorderId) {
	
	$orderMag = $objectManager->create('\Magento\Sales\Model\OrderRepository')->get($currentorder);

   $comp = "";
   $datum = "";
   if($orderMag->getId()=="") {$killer=true;} else {
	   $order = $orders->appendChild($dom->createElement('ORDER'));
	   $comp = $orderMag->getBillingAddress()->getCompany();
	   if (strlen($comp) < 3) {
		$comp = $orderMag->getBillingAddress()->getName();
	   }
	   $datum = str_replace('.','-',$orderMag->getCreatedAt());
	   $datum2 = substr($orderMag->getCreatedAt(),0,10);
	 /* START - ORDER Attributes */
	   sz_cElement($dom, $order, 'ORDERHEAD_CODE', $orderMag->getIncrementId());
	   sz_cElement($dom, $order, 'ORDERHEAD_TIMESTAMP', $datum);
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_NAME', $comp);
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_ZIP', $orderMag->getBillingAddress()->getPostcode());
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_CITY', $orderMag->getBillingAddress()->getCity());
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_ADDRESS', $orderMag->getBillingAddress()->getStreet()[0]);
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_TAX_NO', '');
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_EU_TAX_NO', '');
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_COUNTRY_INTERNATIONAL_CODE', $orderMag->getBillingAddress()->getCountry());
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_LANG_CODE', 'EN');
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_OTHER_DATA', '');   
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_MAIL_IS_SAME', '0');
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_MAIL_NAME', $comp);
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_MAIL_ZIP', $orderMag->getBillingAddress()->getPostcode());
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_MAIL_CITY', $orderMag->getBillingAddress()->getCity());
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_MAIL_ADDRESS', $orderMag->getBillingAddress()->getStreet()[0]);
	   sz_cElement($dom, $order, 'ORDERHEAD_PARTNER_MAIL_COUNTRY_INTERNATIONAL_CODE', $orderMag->getBillingAddress()->getCountry());
	   sz_cElement($dom, $order, 'ORDERHEAD_PAYMENTMETHOD_CODE', '0');
	   sz_cElement($dom, $order, 'ORDERHEAD_DATE_SHIPPED', $datum2);
	   sz_cElement($dom, $order, 'ORDERHEAD_DATE_PAYMENT_DUE', $datum2);
	   sz_cElement($dom, $order, 'ORDERHEAD_NO_VAT', '0');
	   sz_cElement($dom, $order, 'ORDERHEAD_NOVATREASON_CODE', 'FAD');
	   sz_cElement($dom, $order, 'ORDERHEAD_CURRENCY_ABBREVIATION', '');
	   sz_cElement($dom, $order, 'ORDERHEAD_SUBJECT', 'Online shopping / Internetes vásárlás');
	   sz_cElement($dom, $order, 'ORDERHEAD_VERIFIED', '1');

	   /* START - ORDER ITEM Attributes */
	   $items = array();
	   foreach ($orderMag->getAllItems() as $item) {
		if (!$item->getParentItem()) {
		  $adokulcs = round($item->getTaxPercent());
		  $adokulcsnev = $adokulcs.' %';
		  $orderitem = $order->appendChild($dom->createElement('ORDERITEM'));      
		  
		  sz_cElement($dom, $orderitem, 'ORDERITEM_PRODUCT_CODE', $item->getSku());
		  sz_cElement($dom, $orderitem, 'ORDERITEM_STAT_NO', 'VTSZ 4901');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_NAME', $item->getName());
		  sz_cElement($dom, $orderitem, 'ORDERITEM_NAME_TRANSLATION', '');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_COMMENT', '');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_COMMENT_TRANSLATION', '');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_UNIT', 'db');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_UNIT_TRANSLATION', 'pcs');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_VAT_CODE', '1');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_VAT_PERCENT', $adokulcs);
		  sz_cElement($dom, $orderitem, 'ORDERITEM_VAT_NAME', $adokulcsnev);
		  sz_cElement($dom, $orderitem, 'ORDERITEM_LIST_PRICE', $item->getPrice());
		  sz_cElement($dom, $orderitem, 'ORDERITEM_PRICE', $item->getPrice());
		  sz_cElement($dom, $orderitem, 'ORDERITEM_QTY', $item->getQtyOrdered());
		  sz_cElement($dom, $orderitem, 'ORDERITEM_DISCOUNT_TYPE', '0');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_DISCOUNT_PERCENT', '');
		}
	   }
	   /* END - ORDER ITEM Attributes 
	   /* START - Shipping cost ITEM Attributes 
	   if ($orderMag->getShippingAmount() > 0) {
		  $orderitem = $order->appendChild($dom->createElement('ORDERITEM'));      
		  
		  sz_cElement($dom, $orderitem, 'ORDERITEM_PRODUCT_CODE', '0');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_STAT_NO', '');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_NAME', 'Szállítási és kezelési költség');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_NAME_TRANSLATION', '');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_COMMENT', '');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_COMMENT_TRANSLATION', '');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_UNIT', 'db');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_UNIT_TRANSLATION', 'pcs');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_VAT_CODE', '1');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_VAT_PERCENT', '25');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_VAT_NAME', '25 %');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_LIST_PRICE', $orderMag->getShippingAmount());
		  sz_cElement($dom, $orderitem, 'ORDERITEM_PRICE', $orderMag->getShippingAmount());
		  sz_cElement($dom, $orderitem, 'ORDERITEM_QTY', '1');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_DISCOUNT_TYPE', '0');
		  sz_cElement($dom, $orderitem, 'ORDERITEM_DISCOUNT_PERCENT', '');

		 
		}
	   /* END - Shipping cost ITEM Attributes */
	   
	 /* END ORDER Attributes */
	  
	   $currentorder++;
	 }
 }
 $dom->formatOutput = true;                  
 $test1 = $dom->saveXML(); 

	
	echo $test1;
	
	exit;

?>